package jdk.internal.org.objectweb.asm.commons;

import java.util.Collections;
import jdk.internal.org.objectweb.asm.tree.TryCatchBlockNode;
import java.util.Comparator;
import jdk.internal.org.objectweb.asm.MethodVisitor;
import jdk.internal.org.objectweb.asm.tree.MethodNode;

public class TryCatchBlockSorter extends MethodNode
{
    public TryCatchBlockSorter(MethodVisitor methodVisitor, int n, String s, String s2, String s3, String[] array) {
        this(327680, methodVisitor, n, s, s2, s3, array);
    }
    
    protected TryCatchBlockSorter(int api, MethodVisitor mv, int access, String name, String descriptor, String signature, String[] exceptions) {
        super(api, access, name, descriptor, signature, exceptions);
        this.mv = mv;
    }
    
    @Override
    public void visitEnd() {
        Collections.sort(this.tryCatchBlocks, new Comparator<TryCatchBlockNode>() {
            @Override
            public int compare(TryCatchBlockNode tryCatchBlockNode, TryCatchBlockNode tryCatchBlockNode2) {
                return this.blockLength(tryCatchBlockNode) - this.blockLength(tryCatchBlockNode2);
            }
            
            private int blockLength(TryCatchBlockNode tryCatchBlockNode) {
                return TryCatchBlockSorter.this.instructions.indexOf(tryCatchBlockNode.end) - TryCatchBlockSorter.this.instructions.indexOf(tryCatchBlockNode.start);
            }
        });
        for (int i = 0; i < this.tryCatchBlocks.size(); ++i) {
            ((TryCatchBlockNode)this.tryCatchBlocks.get(i)).updateIndex(i);
        }
        if (this.mv != null) {
            this.accept(this.mv);
        }
    }
}
